
// This file does not compile as given, but to the best of our knowledge
// the provided code is bug-free.

#include <time.h> // not the only include you need

#define ALLOWED_SECONDS 3 // between this and one less than this

// no need to change this function (just call it appropriately)
// preconditions: 
//   * ans length > set_size (orders to include)
//   * inventory length = d->num_parts
int find_subset(int * ans, sdata_t d, int set_size,
		int * inventory, int order_index, time_t end_time) {
  // end of recursion
  if(set_size==0)
    return 1;
  if(end_time <= time(NULL) || order_index >= d->num_orders)
    return 0;

  int i;
  // see if there is room for this order
  int is_room = 1;
  for(i=0; i < d->num_parts; ++i) {
    inventory[i] -= d->orders[order_index][i];
    if(inventory[i] < 0) // do _not_ short-circut (complicates things below)
      is_room = 0;
  }
  // recur here only if room for us
  if(is_room) {
    int rec_res = find_subset(ans,d,set_size-1,inventory,order_index+1,end_time);
    if(rec_res) { // success; reverse order but that's fine
      ans[set_size-1]=order_index;
      return 1;
    }
  }
  // if no room for us or recursive failure, undo inventory change,
  // then recur without reduced set_size
  for(i=0; i < d->num_parts; ++i) 
    inventory[i] += d->orders[order_index][i];
  return find_subset(ans,d,set_size,inventory,order_index+1,end_time);
}

struct SubsetAns find_maximal_subset(sdata_t d) {
  int i;
  struct SubsetAns ans;
  time_t end_time = time(NULL)+ALLOWED_SECONDS;

  // add more here (sample solution added about 23 lines to this function)

}

